=== debian/changelog ===
ceph (16.2.6-0ubuntu1) impish; urgency=medium

  * New upstream stable release (LP: #1943932).
  * d/p/*: Refresh.

 -- James Page <james.page@ubuntu.com>  Sat, 18 Sep 2021 13:03:53 +0100

ceph (16.2.5-0ubuntu4) impish; urgency=medium

  * d/control: The ISA-L EC plugin changed its build dependency from yasm to
    nasm 2.13.03 or newer (LP: #1940697).

 -- Frode Nordahl <frode.nordahl@canonical.com>  Fri, 10 Sep 2021 14:56:29 +0100

ceph (16.2.5-0ubuntu3) impish; urgency=medium

  * d/librbd1.install: Install any built extensions to librbd.

 -- James Page <james.page@ubuntu.com>  Mon, 06 Sep 2021 09:35:44 +0100

ceph (16.2.5-0ubuntu2) impish; urgency=medium

  * d/rule: Ensure prometheus alerts are installed correctly, resolving
    FTBFS.

 -- James Page <james.page@ubuntu.com>  Wed, 14 Jul 2021 14:08:48 +0100

ceph (16.2.5-0ubuntu1) impish; urgency=medium

  * New upstream point release (LP: #1935817).
  * d/control,ceph-grafana-dashboards.install: Add new binary package
    for Ceph Grafana dashboards.
  * d/control,ceph-prometheus-alerts.install: Add new binary package
    for Ceph Prometheus alerts.

 -- James Page <james.page@ubuntu.com>  Mon, 12 Jul 2021 10:23:08 +0100

ceph (16.2.4-0ubuntu2) impish; urgency=medium

  * No-change rebuild due to OpenLDAP soname bump.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Mon, 21 Jun 2021 17:44:40 -0400

ceph (16.2.4-0ubuntu1) impish; urgency=medium

  * d/rules,control: Enable new crimson-osd package and provide
    seastar based crimson-osd binary.
  * SECURITY UPDATE: New upstream release (LP: #1928645):
    - CVE-2021-3509: Dashboard XSS via token cookie.
    - CVE-2021-3531: Swift API denial of service.
    - CVE-2021-3531: HTTP header injects via CORS in RGW.
    - d/p/bug1925347.patch: Drop, included in release.

 -- James Page <james.page@ubuntu.com>  Tue, 25 May 2021 09:14:52 +0100

ceph (16.2.1-0ubuntu1) impish; urgency=medium

  [ Chris MacNaughton ]
  * d/ceph-base.install: Remove ceph-deploy man page installation
    (LP: #1892448).

  [ James Page ]
  * SECURITY UPDATE: New upstream point release (LP: #1925322):
    - CVE-2021-20288
  * d/rules: remove temporary build objects after install to avoid
    running out of disk space during package builds.
  * d/p/bug1925347.patch: Cherry pick fix to revert ProtectClock
    permissions change in systemd configurations which prevents the
    ceph-osd process from starting (LP: #1925347).

 -- James Page <james.page@ubuntu.com>  Tue, 04 May 2021 19:21:24 +0100
